#SSHTunnel.py
import sshtunnel

class SSHTunnel:
    def __init__(self, ssh_host, ssh_port, ssh_username, ssh_password, remote_host, remote_port, local_port):
        self.ssh_host = ssh_host
        self.ssh_port = ssh_port
        self.ssh_username = ssh_username
        self.ssh_password = ssh_password
        self.remote_host = remote_host
        self.remote_port = remote_port
        self.local_port = local_port
        self.tunnel = None

    def start_tunnel(self):
        self.tunnel = sshtunnel.SSHTunnelForwarder(
            (self.ssh_host, self.ssh_port),
            ssh_username=self.ssh_username,
            ssh_password=self.ssh_password,
            remote_bind_address=(self.remote_host, self.remote_port),
            local_bind_address=('localhost', self.local_port)
        )
        self.tunnel.start()

    def stop_tunnel(self):
        if self.tunnel:
            self.tunnel.stop()